#sudo gem install builder
require 'rubygems'
require 'rexml/document'
require 'builder'

  # http://www.ruby-doc.org/stdlib/libdoc/rexml/rdoc/
  def readXml
    # read in the xml file
    xml = File.read('books.xml')
    
    #parse it with rexml
    doc = REXML::Document.new(xml)
    
    #grab the root node
    root_node = doc.root
    
    #output its name
    puts "Root: "+root_node.name
    
    #get all of the root's sub elements
    books = root_node.elements
    
    #for each of the sub elements..
    books.each do |book|
      
      #again print the name
      puts "\tNode: "+book.name
      print "\tAttributes: "
      
      # iterate over its attributes, print the key and value
      book.attributes.each do |key, val| 
        puts key+"-->"+val+" "
      end
      
      # retrive the book's child elements
      book_children = book.elements
      
      # iterate over each of them
      book_children.each do |book_kid|
        
        #print the relevent information
        puts "\tNode: "+book_kid.name
        puts "\t\tText: "+book_kid.text
        print "\t\tAttributes: "
        # if there are no attributes just print the line terminator
        if book_kid.attributes.size > 0
          book_kid.attributes.each do |key, val| 
            puts key+"-->"+val+" "
          end
        else
          puts ""
        end
      end
    end
  end
  
  # http://www.xml.com/pub/a/2006/01/04/creating-xml-with-ruby-and-builder.html
  def writeXml
    
    # generate a dictionary for sample data
    classes = {"CS100" => "Intro to Programming", "CS201" => "Intro to Databases", "CS302" => "Algorithms", "CS403" => "Data Structures"}
    
    # instantiate a new Builder
    xml = Builder::XmlMarkup.new(:indent => 1)
    
    #put the <xml... line in
    xml.instruct!
    
    # create a classes root element
    #text = xml.classes :classxml do
    text = xml.zoo do
      # for each of the keys in the classes dictionary...
      classes.each do | name, desc |
        #write a sub element class with a desc attribute
        xml.class(name, :desc => desc)
      end
    end
    
    fh = File.open("classes.xml",'w');
    
    fh.puts text
    
  end
  
  readXml()
  writeXml()